Bug 862853 - Review Request: python-odict - Ordered dictionary
Summary: Review Request: python-odict - Ordered dictionary
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Eduardo Echeverria
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 862854
TreeView+ depends on / blocked
 
Reported: 2012-10-03 18:42 UTC by Stephen Gallagher
Modified: 2012-10-24 14:30 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-10-04 20:35:24 UTC
echevemaster: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Stephen Gallagher 2012-10-03 18:42:24 UTC
Spec URL: http://sgallagh.fedorapeople.org/packagereview/python-odict/python-odict.spec
SRPM URL: http://sgallagh.fedorapeople.org/packagereview/python-odict/python-odict-1.5.0-1.fc18.src.rpm
Description:
Dictionary in which the insertion order of items is preserved (using an
internal double linked list). In this implementation replacing an existing
item keeps it at its original position.

Fedora Account System Username: sgallagh

Comment 1 Eduardo Echeverria 2012-10-04 01:54:48 UTC
Hi Stephen

I guess you have plans for EPEL5
You should have this lines in spec:

%if 0%{?rhel} && 0%{?rhel} <= 5
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

http://fedoraproject.org/wiki/Packaging:Python#Macros

Regards

Comment 2 Eduardo Echeverria 2012-10-04 02:28:07 UTC
Hi again
Also...
Since here is a test existing, you should definitely use it!
http://pypi.python.org/pypi/interlude/1.1.1
and 
%clean
rm -rf %{buildroot}

Comment 3 Eduardo Echeverria 2012-10-04 03:44:04 UTC
For the readers:
Tests broken upstream 

Sthepen forget what I said about test

Comment 4 Eduardo Echeverria 2012-10-04 04:28:15 UTC
Hi again 

In the process of renaming the package can use

%global pkgname odict
Name: python-odict
Source0: http://pypi.python.org/packages/source/o/%{pkgname}/%{pkgname}-%{version}.tar.gz
........................
%prep
%setup -q -n %{pkgname}-%{version}
........................
%files
%doc LICENSE.rst README.rst
%{python_sitelib}/%{pkgname}/
%{python_sitelib}/%{pkgname}-%{version}*.egg-info

In http://pypi.python.org/pypi/odict/ I read

Requires Python 2.4+
You could use
BuildRequires: python2-devel
Requires: python2
http://fedoraproject.org/wiki/Packaging:Python#BuildRequires

and in section %files.
%files
%defattr(-,root,root) #for EPEL
%doc LICENSE.rst README.rst

Regards

Comment 5 Stephen Gallagher 2012-10-04 11:56:13 UTC
Thank you for the review! Yes, the upstream tests are broken (and also require network access) so I disabled them from the package build.

I wasn't initially targeting EPEL, but I don't see any reason not to add your recommendations, so that's done.

Spec: http://sgallagh.fedorapeople.org/packagereview/python-odict/python-odict-2.spec

SRPM: http://sgallagh.fedorapeople.org/packagereview/python-odict/python-odict-1.5.0-2.fc18.src.rpm

Koji build: http://sgallagh.fedorapeople.org/packagereview/python-odict/python-odict-1.5.0-2.fc18.src.rpm

Comment 6 Eduardo Echeverria 2012-10-04 13:58:32 UTC
Hi Sthepen

- If tests is are available they must be used, but this tests being broken, are not available,  so you can ignore such. (You can add a comment in the spec)

- Add %clean section in the spec

After that,  I proceed to formal review

Regards

Comment 8 Eduardo Echeverria 2012-10-04 18:24:00 UTC
Hi Stephen
the spec should have the same name of the package 
Incorrect: python-odict-3.spec
Correct: python-odict

something else
the section %check generally should be collocated after %build

Comment 9 Eduardo Echeverria 2012-10-04 18:32:21 UTC
You have macro in comment too 
%{__python}, fix this please; 
Incorrect:
# Tests are broken upstream and also require unpackaged python-interlude
# Uncomment when fixed upstream
# %{__python} setup.py test -m odict.tests 

Correct:
# Tests are broken upstream and also require unpackaged python-interlude
# Uncomment when fixed upstream
# python setup.py test -m odict.tests

Please remove the last dot (.) of the description
Regards

Comment 10 Stephen Gallagher 2012-10-04 18:48:11 UTC
The spec file in the SRPM *does* have the same name as the package. I just renamed it in my fedorapeople space so that you could diff it to the previous versions if you were so inclined. I'll attach a non-renamed version below.

I've removed the python macro and reordered the sections (though the latter I think is a bit pedantic).

Spec: http://sgallagh.fedorapeople.org/packagereview/python-odict/python-odict.spec

SRPM: http://sgallagh.fedorapeople.org/packagereview/python-odict/python-odict-1.5.0-4.fc18.src.rpm

Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=4560445

Comment 11 Eduardo Echeverria 2012-10-04 19:09:35 UTC
I sincerely apologize : (, rpmlint complains about the dots in the summary and in the description. 
Did not mean to bother you
Right now I'm doing the review

Comment 12 Eduardo Echeverria 2012-10-04 19:49:14 UTC
Again, excuse me, and thank you for your patience:

Koji Build Rawhide (OK)
http://koji.fedoraproject.org/koji/taskinfo?taskID=4560545

Koji Build F18 (OK)
http://koji.fedoraproject.org/koji/taskinfo?taskID=4560565

Koji Build F17 (OK)
http://koji.fedoraproject.org/koji/taskinfo?taskID=4560740

Koji Build F16 (OK)
http://koji.fedoraproject.org/koji/taskinfo?taskID=4560837

Koji Build EL5 (with rpmbuild-md5) (OK)
http://koji.fedoraproject.org/koji/taskinfo?taskID=4560854

Koji Build EL6 (OK)
http://koji.fedoraproject.org/koji/taskinfo?taskID=4560841

Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[-]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[-]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[-]: Large documentation files are in a -doc subpackage, if required.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 1 files have unknown license. Detailed output of
     licensecheck in /home/makerpm/862853-python-odict/licensecheck.txt
Python License
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.

Python:
[x]: Package contains BR: python2-devel or python3-devel

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[-]: Buildroot is not present
     Note: Buildroot: present but not needed
[-]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: Package functions as described.
[+]: Latest version is packaged.
[+]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (odict-1.5.0.tar.gz)
http://fedoraproject.org/wiki/Features/PythonNamingDependingOnImplementation
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
Test Upstream is broken
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-odict-1.5.0-4.fc17.noarch.rpm
          python-odict-1.5.0-4.fc17.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python-odict
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
python-odict-1.5.0-4.fc17.noarch.rpm (rpmlib, GLIBC filtered):
    
    python(abi) = 2.7
    python2  



Provides
--------
python-odict-1.5.0-4.fc17.noarch.rpm:
    
    python-odict = 1.5.0-4.fc17



MD5-sum check
-------------
http://pypi.python.org/packages/source/o/odict/odict-1.5.0.tar.gz :
  CHECKSUM(SHA256) this package     : 5f102f7545364348b8a2b3312d32541f1e1c6911d762e9a6a568f82b17a5edd5
  CHECKSUM(SHA256) upstream package : 5f102f7545364348b8a2b3312d32541f1e1c6911d762e9a6a568f82b17a5edd5

----------------

PACKAGE APPROVED

----------------

Comment 13 Stephen Gallagher 2012-10-04 19:55:00 UTC
New Package SCM Request
=======================
Package Name: python-odict
Short Description: Ordered dictionary
Owners: sgallagh
Branches: f18 f17
InitialCC:

Comment 14 Gwyn Ciesla 2012-10-04 19:59:54 UTC
Git done (by process-git-requests).

Comment 15 Stephen Gallagher 2012-10-04 20:31:47 UTC
Package Change Request
======================
Package Name: python-odict
New Branches: f16 el6 el5
Owners: sgallagh tato650
InitialCC: tato650

Eduardo has volunteered to comaintain this package in additional branches.

Comment 16 Stephen Gallagher 2012-10-04 20:39:21 UTC
Package Change Request
======================
Package Name: python-odict
New Branches: f16 el6 el5
Owners: sgallagh echevemaster
InitialCC: echevemaster

Eduardo has volunteered to comaintain this package in additional branches.
Pardon for the earlier incorrect name. Bad zodbot lookup. Two Eduardo Echeverrias

Comment 17 Gwyn Ciesla 2012-10-04 21:08:32 UTC
Git done (by process-git-requests).

Comment 18 Fedora Update System 2012-10-04 23:37:03 UTC
python-odict-1.5.0-4.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/python-odict-1.5.0-4.fc16

Comment 19 Fedora Update System 2012-10-05 00:06:50 UTC
python-odict-1.5.0-4.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-odict-1.5.0-4.el6

Comment 20 Fedora Update System 2012-10-05 00:45:39 UTC
python-odict-1.5.0-4.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/python-odict-1.5.0-4.el5

Comment 21 Fedora Update System 2012-10-24 02:48:16 UTC
python-odict-1.5.0-4.fc16 has been pushed to the Fedora 16 stable repository.

Comment 22 Fedora Update System 2012-10-24 14:30:32 UTC
python-odict-1.5.0-4.el5 has been pushed to the Fedora EPEL 5 stable repository.

Comment 23 Fedora Update System 2012-10-24 14:30:48 UTC
python-odict-1.5.0-4.el6 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.